//
//  SRUtilities.h
//  SRUtilities
//
//  Created by Raymond Hsu on 5/10/13.
//
//

#import "SRSingletonMacro.h"
#import "SRLog.h"
#import "SRExtendedClasses.h"
#import "NSDictionary_JSONExtensions.h"
#import "SRPermissionsUtilities.h"

void sendWakeOnLan(NSString *ip, int port, NSData *mac);
NSString* SRGetLocalizedString(NSString* string, int OEMMode);

/*
typedef NS_ENUM(NSInteger, SRAuthorizationStatus) {
    SRAuthorizationStatusOpenPreferences = -2,
    SRAuthorizationStatusNotNeedAuthorized = -1,
    SRAuthorizationStatusNotDetermined = 0,
    SRAuthorizationStatusRestricted    = 1,
    SRAuthorizationStatusDenied        = 2,
    SRAuthorizationStatusAuthorized    = 3,
};
*/

@interface SRUtilities : NSObject

+ (unsigned int) timeStamp;
+ (unsigned long) currentTime;
+ (NSComparisonResult) compareVersion:(NSString*)currentVersion withVersion:(NSString*)targetVersion;
+ (void)printDataAsHex :(NSData*)data ;
+ (UInt64)getFileSize :(NSString*)path ;
+ (void)toggleAddPrinter:(id)sender;
+ (void)toggleRMPrinter:(id)sender;
+ (BOOL)isVirtualPrinterExist ;

+ (uint32_t)osVersionNumber;
+ (NSString *)osVersionString;
+ (NSString *)osVersionCodeName;
+ (NSData*)queryCurrentMacUserUUID;
+ (NSData*)queryMacUserUUID:(NSString*)userName password:(NSString*)password;
+ (NSString*) authMacUser:(NSString*)userName password:(NSString*)password isAdmin:(BOOL*)isAdmin;
+ (NSString*) getMacUserFullName:(NSString*)userName;

+ (NSDictionary*) parseBackendResultJsonString:(NSString*)dataString;
+ (NSString*) getSRBackendCommandTypeString:(int)type;
+ (NSString*) getSRBackendCommandSubTypeString:(int)type subType:(int)subType;
+ (NSString*) getSRHTTPMethodString:(int)method;
+ (NSString*) getSRBackendActionString:(int)action;
//+ (NSString*) getJsonStringFromDictionary:(NSDictionary*)dictionary;

+ (BOOL)isPrinterDriverInstalled;
+ (void)openSystemProxySettings;

+ (void)setWindowCenterOrigin:(NSWindow*) window baseWindow:(NSWindow*) referWindow;
+ (NSArray*) collectUserCrashReportToPath:(NSString*)path currentUserName:(NSString*)userName withPrefix:(NSString*)prefix;
+ (NSArray*) collectSystemCrashReportToPath:(NSString*)path withPrefix:(NSString*)prefix;

+ (void) openSystemPreference:(NSString *)_option;
+ (void) openSystemPreferenceSecurity:(NSString *)_option;
+ (void) openSystemPreferenceSecurityPrivacy:(NSString *)_option;

#if ATTENDED_STREAMER
+ (BOOL)isSOSAgentInstalled:(NSString*)agentProcessName;
+ (BOOL)isSOSAgentInstalledForReboot:(NSString*)agentProcessName;
#endif

+ (NSString*) MacDeviceWithIdentifierName:(NSString *)_model;
+ (NSString*) DeviceModelFinder;
+ (void) wakeUpDisplay;

//+ (void) micPermissionAuthorizationStatus:(void (^)(int authStatus))handler;
//+ (void) accessMicPermission:(void (^)(BOOL granted))handler;
+ (BOOL) isCurrentUserSystemAdmin;

+ (NSString*) getConsoleUserName;
+ (uid_t) getConsoleUserID;
+ (NSString*) getDomainForUser:(NSString*)_user;

+ (NSString*) systemInfoString:(const char*)attributeName;
+ (NSString*) fullHostName;
+ (NSString*) hostName;

+ (NSArray*) getSystemInfo:(NSString*) _type;
+ (NSArray*) getAllNetworkInterfaces;

+ (NSString*) getSystemExtensionsPath;

+ (BOOL) isFileVaultEnabled;

+ (uint64_t) getCurrentProcessMemoryUsage;

+ (NSString*) mountDmgAndGetMountPoint:(NSString*)dmgFileName;

+ (NSString *)runCommand:(NSString *)commandToRun;

+ (void) insertDictionary:(NSDictionary*)source toDictionary:(NSMutableDictionary*)target;

+ (NSString*)getAutoDeployCodeFromMountPoint:(NSString*)installerSourceFile;

+ (BOOL) isValidAlphaNumericString:(NSString*)string;

+ (NSString*) getDMGFileNameFromVolumeName:(NSString*)volumeName;

+ (NSString*) runCommand:(NSString*)_command withArguments:(NSArray*)_arguments;
@end
